/**
 * Created on 14.04.2006
 * : ..
 *
 *    ,   
 *  ,    .
 *
 */

//      
import java.util.Stack;

public class Analyser {
    /**
     *  Position       .
     *     .
     */
	private static class Position {
		String src;     //  
		int ndx = -1;   //   

        //      
		public Position(String s) { src = s; }

        //  nextChar      
		public char nextChar() {
            //    
			while (++ndx < src.length() && Character.isWhitespace(src.charAt(ndx)))
				;
            //       ,  
            //    -    0.
			return (ndx >= src.length() ? 0 : src.charAt(ndx));
		}

        //      
        public int getIndex() { return ndx; }
	}

    /**
     *     -    .
     */
	public static class ErrorException extends RuntimeException {
        //  
		static public final int ERROR_NO_OPERAND = 1;
		static public final int ERROR_NO_OPERATOR = 2; 
		static public final int ERROR_DISBALANCE = 3;
		
		private int code;       //  
		private int position;   //   

        // 
		public ErrorException(int code, String message, int position) {
			super(message);
			this.code = code;
			this.position = position;
		}

        //      
		public int getCode() { return code; }
		public int getPosition() { return position; }
        //public String getMessage();
	}

    /**
     *    . ,    3
     *  :    (  1)
     *   (  2).   
     *    (0)
     *
     * @param c -  
     * @return  - 
     */
	public static int prio(char c) {
		switch(c) {
			case '+': case '-':  return 1;
			case '*':            return 2;
			case '(':            return 0;
			default:             return -1;
		}
	}
	
	/**
     *   .    
     *  (  ),     .
     *
     * @param src  -  ,     
     * @return     - ,        
     */
	public static String analyse(String src) {
		StringBuffer output = new StringBuffer();   //  
		Position currPos = new Position(src);       //     
		char currChar;                              //   
		boolean bOperand = true;                    //  ?
		Stack oper = new Stack();                   //  
		String ops = "+-*";                         //   

        //       
		while ((currChar = currPos.nextChar()) != 0) {
			if (bOperand) {
                //  : ,    
				if (Character.isLetterOrDigit(currChar)) {
                    //       
					output.append(currChar).append(" ");
                    //        
					bOperand = false;
				} else if (currChar == '(') {
                    //      
					oper.push(new Character(currChar));
				} else {
                    // :      !
					throw new ErrorException(ErrorException.ERROR_NO_OPERAND, "No operand found!", currPos.ndx);
				}
			} else {
                //      
				if (ops.indexOf(currChar) >= 0) {
                    //        
					int myPrio = prio(currChar);
                    //         
                    //        
					while (!oper.isEmpty() && prio(((Character)oper.peek()).charValue()) >= myPrio) {
						output.append(oper.pop()).append(" ");
					}
                    //        
					oper.push(new Character(currChar));
                    //     
					bOperand = true;
				} else if (currChar == ')') {
                    //   :     
                    //         
					while(!oper.isEmpty() && ((Character)oper.peek()).charValue() != '(') {
						output.append(oper.pop()).append(" ");
					}
					if (oper.isEmpty()) {
                        //     !
						throw new ErrorException(ErrorException.ERROR_DISBALANCE, "No correspondent left paranthesis",
                                currPos.getIndex());
					} else {
                        //      
						oper.pop();
					}
				}
			}
		}
        //              .
		while(!oper.isEmpty() && ((Character)oper.peek()).charValue() != '(') {
			output.append(oper.pop()).append(" ");
		}
        //        ,   !
		if (!oper.isEmpty()) throw new ErrorException(ErrorException.ERROR_DISBALANCE, "Extra left parenthesis",
                currPos.getIndex());
        //  -  
		return output.toString();
	}

    /**
     *           
     *           
     *
     * @param src -  
     */
    public static void test(String src) {
        try {
            System.out.println(src);
            System.out.println(analyse(src));
        } catch (ErrorException x) {
            StringBuffer pointer = new StringBuffer();
            int pos = x.getPosition();
            while (pos-- > 0) pointer.append(' ');
            System.out.println(pointer.append('^'));
            System.out.println("Error: " + x.getMessage());
        }
        System.out.println();
    }

    /**
     *      ,  
     *   ,      .
     *
     * @param args
     */
	public static void main(String[] args) {
        test("(a + b + c)*(1 +  3*x)");
        test("(a + b + c) * ((1 +  3*x)");
        test("(a + b + c)) * (1 +  3*x)");
	}
}
